;+------------------------------------------------------+
;|	 _________     ________    _________		|
;|	/\   _____\   /  ____  \  /\   _____\		|
;|	\ \  \____/  /\  \   \  \ \ \  \____/		|
;|	 \ \  \_____ \ \  \   \  \ \ \  \_____		|
;|	  \ \_____  \ \ \  \   \  \ \ \_____  \		|
;|	   \/____/\  \ \ \  \   \  \ \/____/\  \	|
;|	     ____\_\  \ \ \  \___\  \  ____\_\  \	|
;|	    /\_________\ \ \________/ /\_________\	|
;|	    \/_________/  \/_______/  \/_________/ v1.7	|
;|							|
;+----------->by Joe Wingbermuehle 19990103<------------+
;| See sos.txt for information about SOS.		|
;| Please do not modify this code!			|
;| Visit my home page at:  http://www.usmo.com/~joewing	|
;| Send comments/bugs to:  joewing@usmo.com		|
;+------------------------------------------------------+

	.nolist
	#include	"joeti83.inc"
	.org		$9327

#define	BASIC

;---------= Variables =---------
; Values stored in safe ram areas
storage		=sram
progname	=storage	; name of the program (10 bytes)
fatmap		=storage+10	; program number/fat location (2*8=16 bytes)

; Values stored in instructions
#define	progloc		progloc_lbl+1	; location of the program
#define	progsize	progsize_lbl+1	; size of the program
#define	progdes		progdes_lbl+1	; pointer to the description
#define	number		number_lbl+1	; number of programs on the screen
#define	nextprog	nextprog_lbl+1	; pointer to the next program in the vat

; Values stored in instructions that must have a certain value at startup
#define	highlighted	highlighted_lbl+1	; number of the highlighted program
#define	curfat		curfat_lbl+1	; pointer to the start of the page in the vat

	.list

;---------= Beginning of SOS! =---------
startofsos:
	im	1
	set	1,(iy+8)
	ld	hl,$8600
	ld	a,h
	ld	bc,$0093
loadInterrupt:
	ld	(hl),c
	inc	hl
	djnz	loadInterrupt
	ld	(hl),c
	ld	i,a

curfat_lbl:
	ld	hl,$0000
	ld	a,h
	or	l
	jr	nz,ppstrt
strtpg:	ld	hl,(fat)
ppstrt:	ld	(nextprog),hl
start:	call	rindoff
	call	clrgbuf
	set	7,(iy+20)
	ld	hl,(nextprog)
	ld	(curfat),hl
	xor	a
	ld	(number),a

	dec	a
	ld	hl,gbuf+(12*6)
	ld	b,12
drawTopL:
	ld	(hl),a
	inc	hl
	djnz	drawTopL

	ld	hl,fatmap
	ld	bc,8*256+7
dispp:	push	bc
	push	hl
nextprog_lbl:
	ld	hl,$0000
	call	findprog
	ld	(nextprog),hl
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	pop	bc
	jr	nz,nomore
	push	hl
	ld	l,$01
	ld	h,c
	ld	(pencol),hl
progdes_lbl:
	ld	hl,$0000
	call	vputs
	ld	hl,number
	inc	(hl)
	pop	hl

;-----> Check for 2nd+on and prevent it
	jr	interrupt_end
interrupt_start:
	ex	af,af'
	in	a,(3)
	rra
	jr	nc,on_not_pressed
	res	3,(iy+18)
on_not_pressed:
	jp	$0039
interrupt_end:

	ld	a,c
	add	a,6
	ld	c,a
	ld	a,$DA
	ld	(running),a
	djnz	dispp
nomore:
running:
	jp	nc,exit		; will be either jp nc or jp c (not taken if nc)
number_lbl:
	ld	a,$00
	or	a
	jr	z,strtpg
progsx:	jr	strthl

;---------= Wait for a key press (with APD) =----------
pmain:
	call	bufcopy
main:	im	2
	res	4,(iy+9)
	set	0,(iy+3)
	call	getkey
	or	a
	jr	nz,mainCont
	rst	38h
	inc	a
	out	(3),a
	halt
	xor	a
mainCont:
	im	1

;---------= Main loop =---------
	ld	hl,highlighted
	cp	73	; [Y=]
	jr	z,run
	cp	5
	jr	z,run
	cp	64	; [2nd]+[MODE]
	ret	z
	cp	1	; [(right)]
	jr	nz,wrong
	ld	(hl),a
	jp	start
wrong:	ld	de,number
	ld	b,(hl)
	sub	3	; [(up)]
	jr	z,up
	dec	a	; [(down)]
	jr	nz,main

;---------= Move the highlight =---------
down:	ld	a,(de)
	sub	(hl)
	jr	nz,mdown
	ld	(hl),a
mdown:	inc	(hl)
mvcomp:	call	hilight
strthl:	call	dispdes
	jr	pmain
up:	dec	(hl)
	jr	nz,mvcomp
	ld	a,(de)
	ld	(hl),a
	jr	mvcomp

;---------= Run a program =---------
run:	call	getdata

;-----> Run BASIC program
#ifdef BASIC
basicflag:
	nop			; either nop ($00) or ccf ($3E)
	jr	nc,runAsm
	call	clrwin
	ld	hl,progname
	rst	20h
	set	1,(iy+8)
	ld	hl,(usermemoff)
	push	hl
	call	$4E8C
	pop	hl
	ld	(usermemoff),hl
	jp	$9327
#endif
;-----<

progloc_lbl:
runAsm:	ld	hl,$0000	; run asm program
	push	hl		; check for libs
	inc	hl
	inc	hl
	inc	hl
	call	ldhlind
	pop	de
	ld	a,h
	or	l
	jr	z,nolibs
	add	hl,de

;-----> Setup library vectors
	; Vector definitions have the following format:
	; "LIB",0,0,0,0,0,libnum,vectnum,[$FF if no more]
libll:	ld	de,op1
	ld	a,5
	ld	(de),a
	inc	de
	ld	c,8	; b=0
	ldir
	push	hl
	call	chksysvar
	inc	de
	inc	de
	pop	hl
	jr	nc,libfnd

libNotFound:
	call	clearSection	; Error if library file not found
	call	bufcopy
	xor	a
	ld	(pencol),a	; penrow=57
	ld	hl,op1+1
	call	vputs
	jp	main

libfnd:	ld	c,(hl)	; lib number (mult of 2)
	push	hl
	ex	de,hl
;	ld	b,$00	; b=0
	push	hl
	add	hl,bc
	call	ldhlind
	pop	de
	add	hl,de
	ex	de,hl
	pop	hl
	inc	hl
	ld	c,(hl)	; vector number (mult of 3)
	push	hl
;	ld	b,$00	; b=0
	ld	hl,cmdshad+40
	add	hl,bc
	ld	(hl),$C3	; jp xxxx
	inc	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	pop	hl
	inc	hl
	ld	a,(hl)
	inc	a
	jr	nz,libll

;-----> Load and Run the asm program
#define	loadarea	cmdshad+(26-(swap-hook))	; swap must be at cmdshad+26!

nolibs:	call	clrwin
	call	clrgbuf
	ld	bc,hookend-hook
	ld	de,loadarea
	push	de
	ld	hl,hook
	ldir
	ld	de,(progloc)
progsize_lbl:
	ld	bc,$0000
	ld	hl,$9327
	ret

hook:	push	bc
ex1:	call	sos_swap
	inc	hl
	inc	de
	jr	nz,ex1
	push	de
	push	hl
	call	$9327
	pop	hl
	pop	de
	pop	bc
ex2:	dec	hl
	dec	de
	call	sos_swap
	jr	nz,ex2
	jp	(hl)

swap:	ld	a,(hl)
	push	af
	ld	a,(de)
	ld	(hl),a
	pop	af
	ld	(de),a
	dec	bc
	ld	a,b
	or	c
	ret
hookend:

;---------= Get info on highlighted prog =---------
getdata:
	ld	hl,fatmap-2
highlighted_lbl:
	ld	bc,$0001
	add	hl,bc
	add	hl,bc
	call	ldhlind

;---------= Detect programs =---------
findprog:
findlp:	push	hl
	ld	a,(hl)
	and	%00011111
	cp	$0D
	jr	z,list
	dec	a	; 1
	jr	z,list
	sub	$04	; 5
	jr	z,chkprg
	dec	a	; 6
	jr	z,chkprg
	pop	de
	ret
chkprg:	dec	hl
	ld	b,(hl)
	dec	hl
	push	hl
	ld	h,(hl)
	ld	l,b
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	(progsize),de
	inc	hl
	ld	(progloc),hl

;-----> Basic program detection
#ifdef BASIC
;	xor	a		; already 0
	ld	de,basicflag
	ld	(de),a
	ld	a,(hl)
	cp	$3E		; ':'
	jr	nz,notbasic
	inc	a
	ld	(de),a		; $3F (ccf) if BASIC
	ld	hl,progname+1
	jr	basicEnter
notbasic:
#endif
;-----<

	inc	hl
	ld	a,(hl)
	cp	$18	; jr xx
	jr	nz,nogood
	dec	hl
	push	hl
	ld	de,$0005
	add	hl,de
	call	ldhlind
	ld	de,-$9327
	add	hl,de
	pop	de
	add	hl,de
basicEnter:
	ld	(progdes),hl
	pop	hl
	dec	hl
	ld	b,(hl)
	ld	a,6
	add	a,b
	ld	(namelength+1),a
	ld	de,progname
	ld	a,5
	ld	(de),a
	inc	de
skprog:	dec	hl
	ld	a,(hl)
	ld	(de),a
	inc	de
	djnz	skprog
	xor	a
	ld	(de),a
	dec	hl
	pop	de
	ret

nogood:	pop	hl
list:	pop	hl
	dec	hl
	dec	hl
	dec	hl
	ld	b,(hl)
	inc	b
nogdlp:	dec	hl
	djnz	nogdlp
	jr	findlp

;---------= Disp hl in small font =---------
vdisphl:
	call	setxxxxop2
	call	op2_to_op1
	jp	dispop1a

;---------= Show a description =---------
dispdes:
	call	getdata
	call	clearSection
	set	7,(iy+20)
	ld	hl,0*256+1
	ld	(pencol),hl
	ld	hl,sostxt
	call	vputs		; title
	ld	a,56
	ld	(pencol),a
	call	vputs		; Free:(free)
	call	memfree
	call	vdisphl
	ld	hl,(64-7)*256+0
	ld	(pencol),hl
	ld	hl,progname+1
	call	vputs		; progname
	ld	a,56
	ld	(pencol),a
	ld	hl,size
	call	vputs		; Size:(size)
namelength:
	ld	hl,$0000
	ld	de,(progsize)
	add	hl,de
	call	vdisphl

exit:	ld	bc,(highlighted-1)
	res	7,(iy+20)

;---------= Highlight a program =---------
hilight:
	ld	l,b
	ld	h,6*12
	call	htimesl
	ld	de,gbuf+12
	add	hl,de
	ld	b,12*7
hilightL:
	ld	a,(hl)
	cpl
	ld	(hl),a
	inc	hl
	djnz	hilightL
	ret

;---------= Clear Bottom Section of Screen =---------
clearSection:
	ld	hl,gbuf+(56*12)
	ld	bc,7*256+255
clearLoop1:
	ld	a,12
clearLoop2:
	ld	(hl),c
	inc	hl
	dec	a
	jr	nz,clearLoop2
	ld	c,a
	djnz	clearLoop1
	ret

;---------= Dialog =---------
sostxt:	.db	"S0S "
sosversion:
	.db	"1.7-Joe W",0
free:	.db	"Free:",0
size:	.db	"Size:",0

endofsos:

.end

SOS for the TI-83 created by Joe Wingbermuehle